#include <stdio.h>
#include <string.h>

#include "str.h"



//returns the first word (defined by characters then a space or a nul terminator)
//from in and copy it to out. out is NUL terminated. count is the number of words
//to ignore.
//in is assumed to be NUL terminated.
//return the length in characters of the word or 0 if no word was found.
int str_get_word(char *out, char *in)
{
	int i;
	for (i = 0; in[i] != ' ' && in[i] != '\0'; i++)
		out[i] = in[i];
	out[i] = '\0';
	return i;
}



//return the index of the given character in a given string. times is the
//number of occurence of the character the function has to discard before
//beginning to look for it.
//return -1 if the character wasn't found.
int str_get_char_index(char *buf, char c, int times)
{
	times++;
	for (int i = 0; buf[i] != '\0'; i++) {
		if (buf[i] == c)
			times--;
		if (times == 0)
			return i;
	}
	return -1;
}
